downloadMonitorVersion  = "2.1.1"
' 2.1.1
'   fixed a performance bug, too much net info was fetched sometimes
'
' 2.1.0
'   added a function to get update notifications for any module you installed:
'
'   newVersion(download_lid,currentVersion,yesFormat,noFormat)
'       download_lid    the id of the module
'       currentVersion  the version you currently have
'       yesFormat       the format of the string to be output when there is an update (default="%new")
'       noFormat        the format when there is no update (default="")
'         in formats "%new" is replaced by the new version, "%cur" is replaced by currentVersion
'
' 2.0.1
'   added 
'       %version 
'       %NEW        to get a warning that there is a new version of this download (this=Samurize Download Monitor)
'
' 2.0.0
'   the "download_lid" parameter is the id for the download (follow the xml link on the download page)
'       ex: download_lid=1193
'
'   the "format" parameter is the output string with the following fields replaced with the obvious:
'	    %title
'	    %author
'	    %link
'	    %hits
'	    %rating
'	    %votes
'	    %comments
'	    %pubDate
' 1.0.0
'   original version

samurizeDownloadFeed    = "http://www.samurize.com/modules/mydownloads/singledownload_xml.php?lid="
downloadMonitorLID      = 1193
defaultFormat           = "%title%b%hits%b%rating%b%comments"

Function mySamurizeDownloads(download_lid,format)
    if (download_lid="") then
        mySamurizeDownloads = "Argument Error"
    else
        if (format="") then
            format = defaultFormat
        end if
    
        s = getPageFromURL(samurizeDownloadFeed&download_lid)
        s = isolateFromXMLPage(s,"download")
        if (len(s)=0) then
            mySamurizeDownloads = "No lid="+download_lid
        else
            mySamurizeDownloads = format
            mySamurizeDownloads = replace(mySamurizeDownloads,"%title"      ,isolateFromXMLPage(s,"title"   ))
            mySamurizeDownloads = replace(mySamurizeDownloads,"%version"    ,isolateFromXMLPage(s,"version" ))
            mySamurizeDownloads = replace(mySamurizeDownloads,"%author"     ,isolateFromXMLPage(s,"author"  ))
            mySamurizeDownloads = replace(mySamurizeDownloads,"%link"       ,isolateFromXMLPage(s,"link"    ))
            mySamurizeDownloads = replace(mySamurizeDownloads,"%hits"       ,isolateFromXMLPage(s,"hits"    ))
            mySamurizeDownloads = replace(mySamurizeDownloads,"%rating"     ,isolateFromXMLPage(s,"rating"  ))
            mySamurizeDownloads = replace(mySamurizeDownloads,"%votes"      ,isolateFromXMLPage(s,"votes"   ))
            mySamurizeDownloads = replace(mySamurizeDownloads,"%comments"   ,isolateFromXMLPage(s,"comments"))
            mySamurizeDownloads = replace(mySamurizeDownloads,"%pubDate"    ,isolateFromXMLPage(s,"pubDate" ))
            mySamurizeDownloads = replace(mySamurizeDownloads,"%pubDate"    ,isolateFromXMLPage(s,"pubDate" ))
            if (InStr(format,"%NEW")>0) then
                mySamurizeDownloads = replace(mySamurizeDownloads,"%NEW",isUpdateAvailable(downloadMonitorLID,downloadMonitorVersion))
            end if
        end if
    end if
End Function

function newVersion(download_lid,currentVersion,yesFormat,noFormat)
    newVersion = latestVersion(download_lid)
    if (strComp(newVersion,currentVersion)=0) then
        format = noFormat
    else
        format = yesFormat
        if (len(yesFormat)=0) then
            format = "%new"
        end if 
    end if
    newVersion = replace(replace(format,"%cur",currentVersion),"%new",newVersion)
end function

'===============================================================================================
'======================================= GENERAL UTILS =========================================
'===============================================================================================
set shell     = CreateObject("WScript.Shell")
set http      = CreateObject("WinHttp.WinHttpRequest.5.1")
set stream    = CreateObject("ADODB.Stream")
set filesys   = CreateObject("Scripting.FileSystemObject")
scriptsDir    = "C:\Program Files\Samurize\Scripts\"

private function regRead(key)
	On Error Resume Next
    regRead = shell.RegRead ("HKCU\Software\tombrus\"&key)
end function

private sub regWrite(key,value)
    shell.RegWrite "HKCU\Software\tombrus\"&key,value
end sub

private function getPageFromURL(url)
    http.Open "GET", url, False
    http.Send
    getPageFromURL = http.ResponseText
end function

private function getImageFromURL(url)
    http.Open "GET", url, False
    http.Send
    getImageFromURL = http.ResponseBody
end function

private sub saveImage(theImage,imagePath)
    stream.Type = 1 			    ' 1=adTypeBinary
    stream.Open
    stream.Write theImage
    stream.SaveToFile imagePath, 2 	' 2=adSaveCreateOverWrite
end sub

private sub createFolder(folder)
    filesys.createFolder(folder)
end sub

private function exists(file)
    exists = filesys.FileExists(file)
end function

private function existsFolder(folder)
    existsFolder = filesys.FolderExists(folder)
end function

private function isolateFromXMLPage(page,tag)
    isolateFromXMLPage = isolateFromPage(page,"<"+tag+">","</"+tag+">",false,false,true)
end function

private function isolateFromPage(page,startPattern,endPattern,includeStart,includeEnd,emptyOnNotFound)
    s   = page
    pos = InStr(s, startPattern)
    if (pos=0) then
        if (emptyOnNotFound) then
            s = ""
        else
            s = "START NOT FOUND: "+startPattern
        end if
    else
        length          = len(s)-pos+1-len(startPattern)
        nextMatchStart  = 1
        if (includeStart) then
            length         = length+len(startPattern)
            nextMatchStart = len(startPattern)+1
        end if
        s   = right(s,length)
        pos = InStr(nextMatchStart,s,endPattern)
        if (pos=0) then
            if (emptyOnNotFound) then
                s = ""
            else
                s = "END NOT FOUND: "+endPattern
            end if
        else
            length = pos-1
            if (includeEnd) then
                length = length+len(endPattern)
            end if
            s = left(s,length)
        end if
    end if
    isolateFromPage = s
end function

private sub convertImage(imageIn,ImageOut,cmds)
    classpath = scriptsDir&"imageConverter.jar"
    javaCmd = "java -classpath """&classpath&""" com.tombrus.imageConverter.Main "
    javaCmd = javaCmd+"-Read """&imageIn&""" "
    javaCmd = javaCmd+cmds
    javaCmd = javaCmd+"-Write """&ImageOut&""""
    shell.run javaCmd,0,true
end sub

private function isUpdateAvailable(lid,currentVersion)
    s = latestVersion(lid)
    if (len(s)=0) then
        isUpdateAvailable = "This module("&lid&") has been discontinued%b"
    elseif (strcomp(s,currentVersion)=0) then
        isUpdateAvailable = ""
    else
        isUpdateAvailable = "New version "&s&" (you have "&currentVersion&")%b"
    end if
end function

private function latestVersion(lid)
    s = getPageFromURL(samurizeDownloadFeed&lid)
    s = isolateFromXMLPage(s,"download")
    latestVersion = isolateFromXMLPage(s,"version")
end function

